#include <pthread.h>
#include "globals.h"
#include "invariants_guards_action.h"



// Timed Automaton ta1
#define FAILURE 0
#define LOC1 1
#define LOC2 2


ta_location_t ta1_locationArray[] = {
  {"FAILURE", 0, 0, NULL, 0, },
  {"LOC1", 1, 0, inv_ta1_0, 2, 
        { {guard_ta1_0, action_ta1_0, LOC2}, {guard_ta1_1, action_ta1_1, FAILURE},}},
  {"LOC2", 0, 0, inv_ta1_1, 2, 
        { {guard_ta1_2, action_ta1_2, LOC1}, {guard_ta1_3, action_ta1_3, FAILURE},}},

};

// Timed Automaton ta2
#define INIT 0
#define ON 1


ta_location_t ta2_locationArray[] = {
  {"INIT", 1, 0, inv_ta2_0, 1, 
        { {guard_ta2_0, action_ta2_0, ON},}},
  {"ON", 0, 0, inv_ta2_1, 1, 
        { {guard_ta2_1, action_ta2_1, INIT},}},

};


int main() {
  basetick = getTick();
#include "clockinit.h"
   pthread_t threadId_ta1;
   pthread_create(&threadId_ta1,NULL,ta_interpreter,(void *)ta1_locationArray);
   pthread_t threadId_ta2;
   pthread_create(&threadId_ta2,NULL,ta_interpreter,(void *)ta2_locationArray);

#include "joins.h"
  exit(0);
}
