#include <sys/time.h>
#include "ta_types.h"

ta_clock basetick;

// Return actual millicsec
ta_clock getTick() {

  ta_clock r;

  struct timeval tv;
  struct timezone tz;

  gettimeofday(&tv,&tz);

  r = tv.tv_sec*1000;
  r += tv.tv_usec/1000;

  return r - basetick;

}


void *ta_interpreter(void *p) {

  char aux[1000];
  ta_location_t *a = (ta_location_t *)p;

  printf("ta_interpreter started\n");fflush(0);

  // Find initial location
  ta_location_t *initLoc = a;
  while ( 1 ) {
    if ( initLoc->initial ) 
      break;
    initLoc++;
  }

  ta_location_t *thisLoc = initLoc;
 
 
  sprintf(aux,"\nFound init loc %s  ",
          initLoc->name);
  write(0,aux,strlen(aux)+1);
  fflush(0);

  while ( 1 ) {

    for ( size_t i = 0; 
          i < thisLoc->numTrans;
	  i++ ) {

      if ( (!thisLoc->trans[i].guard)
           or
           thisLoc->trans[i].guard() ) {
	if ( thisLoc->trans[i].action )
	  thisLoc->trans[i].action();
        thisLoc = 
         &(a[thisLoc->trans[i].tgtLocIdx]);
	sprintf(aux,"\n%lld New location: %s  ",
                getTick(),thisLoc->name);
        write(0,aux,strlen(aux)+1);
	fflush(0);
	break;
      }

    }


  }

  fflush(0);

  return NULL;

}
